#!/bin/bash
NODE_EXPORTER_FOLDER="{{ elktail_node_exporter_metrics_path }}"
METRICS_FILE_NAME="{{ elktail_node_exporter_metrics_file }}"
FILEBEAT_METRICS_PATH="${NODE_EXPORTER_FOLDER}/${METRICS_FILE_NAME}"
TMP_METRICS_PATH=$(mktemp)

log() {
  echo "$(date '+%Y-%m-%d %H:%M:%S') $1"
}

# Get the list of k8s nodes
nodes=($(kubectl get nodes -o jsonpath='{.items[*].metadata.name}'))

# Check if kubectl command ran successfully
if [ $? -ne 0 ]; then
  log "ERROR: Failed to get Kubernetes nodes."
  exit 1
fi

# Check if there are any nodes
{% raw %}
if [ ${#nodes[@]} -eq 0 ]; then 
{% endraw %}
  log "ERROR: No Kubernetes nodes found."
  exit 1
fi

# Construct the node condition for the elktail command
{% raw %}
if [ ${#nodes[@]} -gt 0 ]; then
{% endraw %}
  node_conditions="AND (agent.name: ${nodes[0]}"
{% raw %}  
  for node in "${nodes[@]:1}"; do
{% endraw %}    
    node_conditions+=" OR agent.name: ${node}"
  done
  node_conditions+=" )"
else
  log "ERROR: No Kubernetes nodes found."
  exit 1
fi

# log "node_conditions=$node_conditions"

log "Get calico-system logs..."
elktail_command="{{ elktail_check_command }}"
#log "elktail_command=$elktail_command"

elktail_check_command_filter='{{ elktail_check_command_filter }}'
#log "elktail_check_command_filter=$elktail_check_command_filter"

elktail_check_command_filter=$(echo "$elktail_check_command_filter" | sed "s/NODES/$node_conditions/")
#log "elktail_check_command_filter=$elktail_check_command_filter"
#log "elktail_command_final=$elktail_command $elktail_check_command_filter"

# Run the elktail command
elktail_output=$(eval $elktail_command $elktail_check_command_filter) || {
  log "ERROR: Failed to run elktail command."
  exit 1
}

log_count=$(echo "$elktail_output" | wc -l)
log "Got $log_count lines"

# Aarray to hold the nodes not present in the logs
missing_nodes=()

# Loop through each node and check if it is mentioned in the elktail logs
for node in "${nodes[@]}"; do
  if ! echo "$elktail_output" | grep -q "$node"; then
    # Add the node to the missing_nodes array
    missing_nodes+=("$node")

    echo "node_filebeat_no_metrics_in_namespace{k8s_node=\"$node\", k8s_namespace=\"{{ elktail_check_namespace }}\", interval=\"{{ elktail_check_time_interval_minutes }}\"} 0" >> "${TMP_METRICS_PATH}"

  else
    echo "node_filebeat_no_metrics_in_namespace{k8s_node=\"$node\", k8s_namespace=\"{{ elktail_check_namespace }}\", interval=\"{{ elktail_check_time_interval_minutes }}\"} 1" >> "${TMP_METRICS_PATH}"
  fi
done

# Make metrics file world readable
chmod 644 "${TMP_METRICS_PATH}"

# Atomically update the prometheus metrics file
mv "${TMP_METRICS_PATH}" "${FILEBEAT_METRICS_PATH}"

# Check if there are any missing nodes
{% raw %}
if [ ${#missing_nodes[@]} -ne 0 ]; then
{% endraw %}
  # Convert the missing_nodes array to a comma-separated string
  missing_nodes_list=$(IFS=, ; echo "${missing_nodes[*]}")
  log "missing_nodes=$missing_nodes_list"
else
  log "All nodes are present in the {{ elktail_check_namespace }} logs."
fi
